// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef DWB_MSGS__SRV__GET_CRITIC_SCORE__RESPONSE__STRUCT_HPP_
#define DWB_MSGS__SRV__GET_CRITIC_SCORE__RESPONSE__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "dwb_msgs/msg/critic_score.hpp"  // score

#ifndef _WIN32
# define DEPRECATED_dwb_msgs_srv_GetCriticScore_Response __attribute__((deprecated))
#else
# define DEPRECATED_dwb_msgs_srv_GetCriticScore_Response __declspec(deprecated)
#endif

namespace dwb_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetCriticScore_Response_
{
  using Type = GetCriticScore_Response_<ContainerAllocator>;

  explicit GetCriticScore_Response_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : score(_init)
  {
    (void)_init;
  }

  explicit GetCriticScore_Response_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : score(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _score_type =
    dwb_msgs::msg::CriticScore_<ContainerAllocator>;
  _score_type score;

  // setters for named parameter idiom
  Type * set__score(
    const dwb_msgs::msg::CriticScore_<ContainerAllocator> & _arg)
  {
    this->score = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_dwb_msgs_srv_GetCriticScore_Response
    std::shared_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_dwb_msgs_srv_GetCriticScore_Response
    std::shared_ptr<dwb_msgs::srv::GetCriticScore_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetCriticScore_Response_ & other) const
  {
    if (this->score != other.score) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetCriticScore_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetCriticScore_Response_

// alias to use template instance with default allocator
using GetCriticScore_Response =
  dwb_msgs::srv::GetCriticScore_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace dwb_msgs

#endif  // DWB_MSGS__SRV__GET_CRITIC_SCORE__RESPONSE__STRUCT_HPP_
