#ifndef GETCRITICSCORE_REQUEST_SPLTYPES_H
#define GETCRITICSCORE_REQUEST_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_GetCriticScore_Request_.h"
#include "Pose2DStamped_SplDcps.h"
#include "Twist2D_SplDcps.h"
#include "Path2D_SplDcps.h"
#include "Trajectory2D_SplDcps.h"



extern c_metaObject __GetCriticScore_Request__dwb_msgs__load (c_base base);

extern c_metaObject __GetCriticScore_Request__dwb_msgs_srv__load (c_base base);

extern c_metaObject __GetCriticScore_Request__dwb_msgs_srv_dds___load (c_base base);

extern const char *dwb_msgs_srv_dds__GetCriticScore_Request__metaDescriptor[];
extern const int dwb_msgs_srv_dds__GetCriticScore_Request__metaDescriptorArrLength;
extern const int dwb_msgs_srv_dds__GetCriticScore_Request__metaDescriptorLength;
extern c_metaObject __dwb_msgs_srv_dds__GetCriticScore_Request___load (c_base base);
struct _dwb_msgs_srv_dds__GetCriticScore_Request_ ;
extern  v_copyin_result __dwb_msgs_srv_dds__GetCriticScore_Request___copyIn(c_base base, const struct dwb_msgs::srv::dds_::GetCriticScore_Request_ *from, struct _dwb_msgs_srv_dds__GetCriticScore_Request_ *to);
extern  void __dwb_msgs_srv_dds__GetCriticScore_Request___copyOut(const void *_from, void *_to);
struct _dwb_msgs_srv_dds__GetCriticScore_Request_ {
    struct _nav_2d_msgs_msg_dds__Pose2DStamped_ pose_;
    struct _nav_2d_msgs_msg_dds__Twist2D_ velocity_;
    struct _nav_2d_msgs_msg_dds__Path2D_ global_plan_;
    struct _dwb_msgs_msg_dds__Trajectory2D_ traj_;
    c_string critic_name_;
};

#undef OS_API
#endif
